;*************************************************************************
;** mmu.library                                                         **
;**                                                                     **
;** a system library for arbitration and control of the MC68K MMUs      **
;**                                                                     **
;**  1998 THOR-Software, Thomas Richter                                **
;** No commercial use, reassembly, modification without prior, written  **
;** permission of the authors.                                          **
;** Including this library in any commercial software REQUIRES a        **
;** written permission and the payment of a small fee.                  **
;**                                                                     **
;** This is an internal header file, do not depend on anything here.    **
;** Use the official include files.                                     **
;** Distributed only for the mmu.library development group for private  **
;** use.                                                                **
;**                                                                     **
;**---------------------------------------------------------------------**
;** Block: Output of debug information                                  **
;*************************************************************************


;FOLD Includes
        include inc:macros.asm
        include inc:exec_lib.asm
;ENDFOLD
        section main_code,code
;FOLD _KaputtString
;*************************************************
;** _KaputtString                               **
;** output the fmtstring *a0, stream *a1        **
;** over the serial port                        **
;*************************************************
        xdef _KaputtString
_KaputtString:
        saveregs d0-d1/a0-a4/a6

        move.l a0,a2
        move.l a1,a3
        move.l ExecBase,a4              ;for later use
        move.l a4,a6
        jsr RawIOInit(a6)

        jsr RawMayGetChar(a6)
        cmp.b #$13,d0                   ;^S ?
        bne.s .nostop
        do
         jsr RawMayGetChar(a6)
         cmp.b #$11,d0                  ;^Q ?
        while.s ne
.nostop:
        move.l a2,a0
        move.l a3,a1
        lea __Output(pc),a2
        move.l a4,a3
        jsr RawDoFmt(a6)

        loadregs
        rts
__Output:
        move.l a3,a6
        jmp RawPutChar(a6)
;ENDFOLD







