;*************************************************************************
;** mmu.library                                                         **
;**                                                                     **
;** a system library for arbitration and control of the MC68K MMUs      **
;**                                                                     **
;**  1998 THOR-Software, Thomas Richter                                **
;** No commercial use, reassembly, modification without prior, written  **
;** permission of the authors.                                          **
;** Including this library in any commercial software REQUIRES a        **
;** written permission and the payment of a small fee.                  **
;**                                                                     **
;** This is an internal header file, do not depend on anything here.    **
;** Use the official include files.                                     **
;** Distributed only for the mmu.library development group for private  **
;** use.                                                                **
;**                                                                     **
;**---------------------------------------------------------------------**
;** Block: Alerts header                                                **
;** Definition of alert codes                                           **
;*************************************************************************

AN_MMULib       equ $3e000000

AN_NoUtility    equ $3e02800c   ;Library init failed to open the utility library
AN_NoExpansion  equ $3e02800a   ;Library init failed to open the expansion library
AN_ContextOpen  equ $3e090001   ;while flushing the library, a context was still in use
AN_BadFreePool  equ $3e018005   ;the memory pool is damaged
AN_NoPoolMem    equ $3e018001   ;no memory to build the pool on lib init
AN_NoContext    equ $3e018002   ;failure building the context
AN_MMUInit      equ $3e000002   ;MMU Init vector failed
AN_IllegalTT    equ $3e000003   ;Transparent translation mode unsupported
AN_IllegalMMU   equ $3e000004   ;MMU table layout not supported
AN_BadContext   equ $3e000005   ;The context contained unaligned mappings
AN_BadTable     equ $3e000006   ;The MMU table build by the library is damaged
AN_FreeActive   equ $3e000007   ;Someone tried to release an active Context

