;*************************************************************************
;** mmu.library                                                         **
;**                                                                     **
;** a system library for arbitration and control of the MC68K MMUs      **
;**                                                                     **
;**  1998 THOR-Software, Thomas Richter                                **
;** No commercial use, reassembly, modification without prior, written  **
;** permission of the authors.                                          **
;** Including this library in any commercial software REQUIRES a        **
;** written permission and the payment of a small fee.                  **
;**                                                                     **
;** This is an internal header file, do not depend on anything here.    **
;** Use the official include files.                                     **
;** Distributed only for the mmu.library development group for private  **
;** use.                                                                **
;**                                                                     **
;**---------------------------------------------------------------------**
;** Block: Abstraction layer for page descriptors                       **
;** Version 0.00                24.09.1998       THOR                  **
;*************************************************************************

;FOLD The abstraction of a descriptor
;*************************************************
;** Descriptor                                  **
;*************************************************
        rsreset
atd_Pointer:    rs.l 1          ;pointer to the table or the next level
atd_Properties: rs.l 1          ;property flags
atd_LowerLimit: rs.w 1          ;lower limit. 0 if none. Given in entries of the next level
atd_UpperLimit: rs.w 1          ;upper limit. 0x7fff if none
atd_ThisType:   rs.b 1          ;Type of this descriptor, see below
atd_NextType:   rs.b 1          ;Next type, long or short. Everything else doesn't care
atd_reserved:   rs.w 1
atd_len:        rs.b 0
;ENDFOLD
;FOLD Descriptor Types
;*************************************************
;** Descriptor Types                            **
;*************************************************
atdt_invalid    =       0       ;invalid descriptor
atdt_page       =       1       ;page descriptor, alternatively early termination
atdt_table      =       2       ;table descriptor
atdt_indirect   =       3       ;indirect descriptor

atdf_long       =       2       ;set if this is long
atdt_long       =       4       ;the same as mask
;ENDFOLD

